#rm(list=ls())
memory.size(max=TRUE);    memory.limit(size=9999999999999)    #to maximize the memory size
library(Hmisc);    library(dummies);    library(random)
library(lubridate);    library(datetime)
set.seed(900)


train= read.csv("D:/American16NovHackathon/train_amex/train.csv")
test= read.csv("D:/American16NovHackathon/test.csv")
sample= read.csv("D:/American16NovHackathon/sample_submission_2s8l9nF.csv")
hist= read.csv("D:/American16NovHackathon/train_amex/historical_user_logs.csv")

#as.datetime("2017-07-02 00:04", format= "%Y-%m-%d %H:%M") > as.datetime("2017-07-02 00:07", format= "%Y-%m-%d %H:%M")

############################################
hist$action= as.character(hist$action)
test1= test;     test1$is_click=as.integer(NA)
traintest= rbind(train, test1)
traintest$action= as.character("0")


userproductcombo= as.data.frame(cbind(as.character(traintest$user_id), as.character(traintest$product)))
colnames(userproductcombo)= c("user_id", "product")
userproductcombo[,1]= as.character(userproductcombo[,1]);    userproductcombo[,2]= as.character(userproductcombo[,2])
userproductcombo$useridproduct= paste(userproductcombo[,1], userproductcombo[,2], sep="")
uniqueuserproductcombo= unique(userproductcombo$useridproduct)

  
hist1= hist[which((hist$user_id %in% traintest$user_id)), ]
hist1$useridproduct= paste(as.character(hist1$user_id), as.character(hist1$product), sep="")
hist2= hist1[which((hist1$useridproduct %in% uniqueuserproductcombo)), ]

traintest$useridproduct= paste(as.character(traintest$user_id), as.character(traintest$product), sep="")
hist2[,2]= NULL;    hist2[,2]= NULL
hist2$all= paste(as.character(hist2$DateTime), as.character(hist2$product), as.character(hist2$useridproduct), sep=" ")
hist3=hist2[!duplicated(hist2), ]


hist4= hist3[c(2852903:1) , c(1:3)]
hist5=hist4[!duplicated(hist4$useridproduct), ]
traintest2= traintest
traintest2$action <- hist5$action[match(traintest2$useridproduct, hist5$useridproduct)]


traintest2$useridproduct= NULL
traintest2$action= replace(traintest2$action, which(is.na(traintest2$action)), "NotVisited")


traintest3= traintest2
traintest3$user_id= NULL
traintest3$campaign_id= as.factor(as.character(traintest3$campaign_id))
traintest3$webpage_id= as.factor(as.character(traintest3$webpage_id))
traintest3$product_category_1= as.factor(as.character(traintest3$product_category_1))
traintest3$product_category_2= as.factor(as.character(traintest3$product_category_2))
traintest3$user_group_id= as.factor(as.character(traintest3$user_group_id))
traintest3$gender= as.factor(as.character(traintest3$gender))
traintest3$age_level= as.factor(as.character(traintest3$age_level))
traintest3$user_depth= as.factor(as.character(traintest3$user_depth))
traintest3$city_development_index= as.factor(as.character(traintest3$city_development_index))
traintest3$action= as.factor(as.character(traintest3$action))

traintest3$is_click= as.numeric(as.character(traintest3$is_click))
traintest3$var_1= NULL


traintest3$DateTime= as.character(traintest3$DateTime)
traintest3$DateTime= substr(traintest3$DateTime, 12, 16)
traintest3$TimeClass= traintest3$DateTime
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("03:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("00:00", format= "%H:%M"))), "0")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("06:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("03:00", format= "%H:%M"))), "1")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("09:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("06:00", format= "%H:%M"))), "2")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("12:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("09:00", format= "%H:%M"))), "3")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("15:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("12:00", format= "%H:%M"))), "4")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("18:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("15:00", format= "%H:%M"))), "5")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") < as.datetime("21:00", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("18:00", format= "%H:%M"))), "6")
traintest3$TimeClass= replace(traintest3$TimeClass, which((as.datetime(traintest3$TimeClass, format= "%H:%M") <= as.datetime("23:59", format= "%H:%M")) & (as.datetime(traintest3$TimeClass, format= "%H:%M") >= as.datetime("21:00", format= "%H:%M"))), "7")


traintest3$TimeClass= as.factor(as.character(traintest3$TimeClass))
traintest3$DateTime= NULL


traintest4= na.omit(traintest3)
traintest4= dummy.data.frame(traintest4, sep=".")
corrr= as.data.frame(cor(traintest4))


traintest5= traintest3[, c("session_id", "product", "campaign_id", "webpage_id", "product_category_1", "action", "TimeClass", "user_group_id", "age_level", "user_depth", "city_development_index", "product_category_2", "gender", "is_click")]
traintest5$gender= as.character(traintest5$gender)
traintest5$gender= replace(traintest5$gender, which(traintest5$gender== ""), NA)
traintest5$gender= as.factor(traintest5$gender)

train2= traintest5[1:463291, ];    test2= traintest5[463292:592149, ];    
test22= test2[order(match(test2$session_id, test$session_id)),]
traintest6= rbind(train2, test22)
#write.csv(traintest6, file="D:/American16NovHackathon/traintest6.csv", row.names= FALSE)
test22$is_click= NULL


##########################################################
#TRAIN2, TEST22
trainraw= train2[, c(1:7, 14)];    testraw= test22[, c(1:7)]
trainrawdummy= dummy.data.frame(trainraw, sep="_")
testrawdummy= dummy.data.frame(testraw, sep="_")
trainrawdummy= trainrawdummy[sample(nrow(trainrawdummy)), ];    trainrawdummy= trainrawdummy[sample(nrow(trainrawdummy)), ];    trainrawdummy= trainrawdummy[sample(nrow(trainrawdummy)), ]
rownames(trainrawdummy)= c(1:nrow(trainrawdummy))

#write.csv(trainrawdummy, file="D:/American16NovHackathon/trainrawdummy.csv", row.names= FALSE)
#write.csv(testrawdummy, file="D:/American16NovHackathon/testrawdummy.csv", row.names= FALSE)


#BALANCE THE DATA
trainrawdummy0= trainrawdummy[which(trainrawdummy$is_click== 0), ]
trainrawdummy1= trainrawdummy[which(trainrawdummy$is_click== 1), ]
trainrawdummyoverunder= rbind(trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1[1:22342,], trainrawdummy0[1:116335,])
trainrawdummyoverunder= trainrawdummyoverunder[sample(nrow(trainrawdummyoverunder)), ];    trainrawdummyoverunder= trainrawdummyoverunder[sample(nrow(trainrawdummyoverunder)), ];    trainrawdummyoverunder= trainrawdummyoverunder[sample(nrow(trainrawdummyoverunder)), ]
#write.csv(trainrawdummyoverunder, file="D:/American16NovHackathon/trainrawdummyoverunder.csv", row.names= FALSE)


trainrawdummyover= rbind(trainrawdummy0, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1, trainrawdummy1[1:24657,])
trainrawdummyover= trainrawdummyover[sample(nrow(trainrawdummyover)), ];    trainrawdummyover= trainrawdummyover[sample(nrow(trainrawdummyover)), ];    trainrawdummyover= trainrawdummyover[sample(nrow(trainrawdummyover)), ]
#write.csv(trainrawdummyover, file="D:/American16NovHackathon/trainrawdummyover.csv", row.names= FALSE)





##################################################
traintest6WithVar= traintest6
traintest6WithVar$var_1= traintest2[order(match(traintest2$session_id, traintest6$session_id)), "var_1"]
traintest6WithVar= traintest6WithVar[, c("session_id", "product", "campaign_id", "webpage_id", "product_category_1", "action", "TimeClass", "var_1", "user_group_id", "age_level", "user_depth", "city_development_index", "product_category_2", "gender", "is_click")]
#write.csv(traintest6WithVar, file="D:/American16NovHackathon/traintest6WithVar.csv", row.names= FALSE)





#########################################################################
traintestusergroup= traintest6WithVar[, 1:9]
traintestusergroup$user_group_id= as.numeric(as.character(traintestusergroup$user_group_id))
traintestusergroup= dummy.data.frame(traintestusergroup, sep="_")

trainusergroup= na.omit(traintestusergroup)
testusergroup= traintestusergroup[which(is.na(traintestusergroup$user_group_id)), ]
testusergroup$user_group_id= NULL
geomeanusergroup= exp(mean(log(table(trainusergroup$user_group_id))))    #12285.6626
trainusergroup= trainusergroup[sample(nrow(trainusergroup)), ];    trainusergroup= trainusergroup[sample(nrow(trainusergroup)), ];    trainusergroup= trainusergroup[sample(nrow(trainusergroup)), ]
rownames(trainusergroup)= c(1:nrow(trainusergroup))


trainusergroup0= trainusergroup[which(trainusergroup$user_group_id== 0), ]
trainusergroup1= trainusergroup[which(trainusergroup$user_group_id== 1), ]
trainusergroup2= trainusergroup[which(trainusergroup$user_group_id== 2), ]
trainusergroup3= trainusergroup[which(trainusergroup$user_group_id== 3), ]
trainusergroup4= trainusergroup[which(trainusergroup$user_group_id== 4), ]
trainusergroup5= trainusergroup[which(trainusergroup$user_group_id== 5), ]
trainusergroup6= trainusergroup[which(trainusergroup$user_group_id== 6), ]
trainusergroup7= trainusergroup[which(trainusergroup$user_group_id== 7), ]
trainusergroup8= trainusergroup[which(trainusergroup$user_group_id== 8), ]
trainusergroup9= trainusergroup[which(trainusergroup$user_group_id== 9), ]
trainusergroup10= trainusergroup[which(trainusergroup$user_group_id== 10), ]
trainusergroup11= trainusergroup[which(trainusergroup$user_group_id== 11), ]
trainusergroup12= trainusergroup[which(trainusergroup$user_group_id== 12), ]

trainusergroupbalance= rbind(trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,
                             trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0, 
                             trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,
                             trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,
                             trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,trainusergroup0,
                             trainusergroup0[1:46,], trainusergroup1[1:12286,], trainusergroup2[1:12286,], trainusergroup3[1:12286,], trainusergroup4[1:12286,], trainusergroup5[1:12286,],
                             trainusergroup6, trainusergroup6, trainusergroup6, trainusergroup6, trainusergroup6, trainusergroup6[1:1136,],
                             trainusergroup7,trainusergroup7,trainusergroup7,trainusergroup7,trainusergroup7,trainusergroup7,trainusergroup7[1:1444,],
                             trainusergroup8, trainusergroup8[1:4445,], trainusergroup9[1:12286,], trainusergroup10[1:12286,], 
                             trainusergroup11, trainusergroup11[1:612,], 
                             trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12, trainusergroup12[1:28,])

trainusergroupbalance= trainusergroupbalance[sample(nrow(trainusergroupbalance)), ];    trainusergroupbalance= trainusergroupbalance[sample(nrow(trainusergroupbalance)), ];    trainusergroupbalance= trainusergroupbalance[sample(nrow(trainusergroupbalance)), ]
rownames(trainusergroupbalance)= c(1:nrow(trainusergroupbalance))

#write.csv(trainusergroupbalance, file="D:/American16NovHackathon/trainusergroupbalance.csv", row.names= FALSE)
#write.csv(testusergroup, file="D:/American16NovHackathon/testusergroup.csv", row.names= FALSE)










########################################################################
usergrouppred= read.csv("D:/American16NovHackathon/Samsung4LBat32Adadel_UserGroupOVERUNDERBesttrainloss.csv")
testusergroup$user_group_id= usergrouppred$user_group_id

traintestusergrouppred= traintestusergroup
a= which(is.na(traintestusergroup$user_group_id))
traintestusergrouppred[a, "user_group_id"]= testusergroup$user_group_id

traintestage= traintestusergrouppred
traintestage$age_level= traintest6$age_level
traintestage$user_group_id= as.factor(as.character(traintestage$user_group_id))


traintestage$age_level= as.numeric(as.character(traintestage$age_level))
traintestage= dummy.data.frame(traintestage, sep="_")

trainage= na.omit(traintestage)    #568222
testage= traintestage[which(is.na(traintestage$age_level)), ]    #23927
testage$age_level= NULL
geomeanagelevel= exp(mean(log(table(trainage$age_level))))    #24316.05199
trainage= trainage[sample(nrow(trainage)), ];    trainage= trainage[sample(nrow(trainage)), ];    trainage= trainage[sample(nrow(trainage)), ]
rownames(trainage)= c(1:nrow(trainage))


trainage0= trainage[which(trainage$age_level== 0), ]
trainage1= trainage[which(trainage$age_level== 1), ]
trainage2= trainage[which(trainage$age_level== 2), ]
trainage3= trainage[which(trainage$age_level== 3), ]
trainage4= trainage[which(trainage$age_level== 4), ]
trainage5= trainage[which(trainage$age_level== 5), ]
trainage6= trainage[which(trainage$age_level== 6), ]

trainagebalance= rbind(trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, trainage0, 
                       trainage0[1:40,], trainage1[1:24316,], trainage2[1:24316,], trainage3[1:24316,],  trainage4[1:24316,],  trainage5[1:24316,], 
                       trainage6, trainage6, trainage6, trainage6, trainage6, trainage6, trainage6[1:2764,])


trainagebalance= trainagebalance[sample(nrow(trainagebalance)), ];    trainagebalance= trainagebalance[sample(nrow(trainagebalance)), ];    trainagebalance= trainagebalance[sample(nrow(trainagebalance)), ]
rownames(trainagebalance)= c(1:nrow(trainagebalance))

#write.csv(trainagebalance, file="D:/American16NovHackathon/trainagebalance.csv", row.names= FALSE)
#write.csv(testage, file="D:/American16NovHackathon/testage.csv", row.names= FALSE)







##################################################################
agepred= read.csv("D:/American16NovHackathon/Samsung4LBat128Adadel_AgeOVERUNDERBesttrainloss.csv")
testage$age_level= agepred$age_level

traintestagepred= traintestage
a= which(is.na(traintestage$age_level))
traintestagepred[a, "age_level"]= testage$age_level

traintestdepth= traintestagepred
traintestdepth$user_depth= traintest6$user_depth
traintestdepth$age_level= as.factor(as.character(traintestdepth$age_level))

traintestdepth$user_depth= as.numeric(as.character(traintestdepth$user_depth))
traintestdepth= dummy.data.frame(traintestdepth, sep="_")

traindepth= na.omit(traintestdepth)    #568222
testdepth= traintestdepth[which(is.na(traintestdepth$user_depth)), ]    #23927
testdepth$user_depth= NULL
geomeandepth= exp(mean(log(table(traindepth$user_depth))))    #67251.88469
traindepth= traindepth[sample(nrow(traindepth)), ];    traindepth= traindepth[sample(nrow(traindepth)), ];    traindepth= traindepth[sample(nrow(traindepth)), ]
rownames(traindepth)= c(1:nrow(traindepth))

traindepth1= traindepth[which(traindepth$user_depth== 1), ]
traindepth2= traindepth[which(traindepth$user_depth== 2), ]
traindepth3= traindepth[which(traindepth$user_depth== 3), ]

traindepthbalance= rbind(traindepth1, traindepth1, traindepth1, traindepth1, traindepth1[1:6460,],
                         traindepth2, traindepth2[1:28322,], traindepth3[1:67252,])


traindepthbalance= traindepthbalance[sample(nrow(traindepthbalance)), ];    traindepthbalance= traindepthbalance[sample(nrow(traindepthbalance)), ];    traindepthbalance= traindepthbalance[sample(nrow(traindepthbalance)), ]
rownames(traindepthbalance)= c(1:nrow(traindepthbalance))

#write.csv(traindepthbalance, file="D:/American16NovHackathon/traindepthbalance.csv", row.names= FALSE)
#write.csv(testdepth, file="D:/American16NovHackathon/testdepth.csv", row.names= FALSE)







#############################################################################
depthpred= read.csv("D:/American16NovHackathon/Samsung4LBat128Adadel_DepthOVERUNDERBesttrainloss.csv")
testdepth$user_depth= depthpred$user_depth

traintestdepthpred= traintestdepth
a= which(is.na(traintestdepth$user_depth))
traintestdepthpred[a, "user_depth"]= testdepth$user_depth

traintestcity= traintestdepthpred
traintestcity$city_development_index= traintest6$city_development_index
traintestcity$user_depth= as.factor(as.character(traintestcity$user_depth))

traintestcity$city_development_index= as.numeric(as.character(traintestcity$city_development_index))
traintestcity= dummy.data.frame(traintestcity, sep="_")

traincity= na.omit(traintestcity)    #432411
testcity= traintestcity[which(is.na(traintestcity$city_development_index)), ]    #159738
testcity$city_development_index= NULL
geomeancity= exp(mean(log(table(traincity$city_development_index))))    #94893.66780
traincity= traincity[sample(nrow(traincity)), ];    traincity= traincity[sample(nrow(traincity)), ];    traincity= traincity[sample(nrow(traincity)), ]
rownames(traincity)= c(1:nrow(traincity))

traincity1= traincity[which(traincity$city_development_index== 1), ]
traincity2= traincity[which(traincity$city_development_index== 2), ]
traincity3= traincity[which(traincity$city_development_index== 3), ]
traincity4= traincity[which(traincity$city_development_index== 4), ]

traincitybalance= rbind(traincity1, traincity1, traincity1[1:6908,],
                        traincity2[1:94894,], traincity3[1:94894,], 
                        traincity4, traincity4[1:8600,])


traincitybalance= traincitybalance[sample(nrow(traincitybalance)), ];    traincitybalance= traincitybalance[sample(nrow(traincitybalance)), ];    traincitybalance= traincitybalance[sample(nrow(traincitybalance)), ]
rownames(traincitybalance)= c(1:nrow(traincitybalance))

#write.csv(traincitybalance, file="D:/American16NovHackathon/traincitybalance.csv", row.names= FALSE)
#write.csv(testcity, file="D:/American16NovHackathon/testcity.csv", row.names= FALSE)







#############################################################################
citypred= read.csv("D:/American16NovHackathon/3Layer4LBat128Adadel_CityOVERUNDERBesttrainloss.csv")
testcity$city_development_index= citypred$city_development_index

traintestcitypred= traintestcity
a= which(is.na(traintestcity$city_development_index))
traintestcitypred[a, "city_development_index"]= testcity$city_development_index

traintestprod2= traintestcitypred
traintestprod2$product_category_2= traintest6$product_category_2
traintestprod2$city_development_index= as.factor(as.character(traintestprod2$city_development_index))

traintestprod2$product_category_2= as.character(traintestprod2$product_category_2)
a= unique(traintestprod2$product_category_2)

traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[2]), "0")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[3]), "1")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[4]), "2")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2== a[5]), "3")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2== a[6]), "4")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[7]), "5")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[8]), "6")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[9]), "7")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[10]), "8")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[11]), "9")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[12]), "10")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[13]), "11")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[14]), "12")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[15]), "13")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[16]), "14")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[17]), "15")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[18]), "16")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[19]), "17")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[20]), "18")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[21]), "19")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[22]), "20")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[23]), "21")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[24]), "22")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[25]), "23")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[26]), "24")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[27]), "25")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[28]), "26")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[29]), "27")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[30]), "28")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[31]), "29")
traintestprod2$product_category_2= replace(traintestprod2$product_category_2, which(traintestprod2$product_category_2==a[32]), "30")

traintestprod2$product_category_2= as.numeric(as.character(traintestprod2$product_category_2))
traintestprod2= dummy.data.frame(traintestprod2, sep="_")

trainprod2= na.omit(traintestprod2)    #150124
testprod2= traintestprod2[which(is.na(traintestprod2$product_category_2)), ]    #442025
testprod2$product_category_2= NULL
geomeanprod2= exp(mean(log(table(trainprod2$product_category_2))))    #40.66653
trainprod2= trainprod2[sample(nrow(trainprod2)), ];    trainprod2= trainprod2[sample(nrow(trainprod2)), ];    trainprod2= trainprod2[sample(nrow(trainprod2)), ]
rownames(trainprod2)= c(1:nrow(trainprod2))


trainprod20= trainprod2[which(trainprod2$product_category_2== 0), ]
trainprod21= trainprod2[which(trainprod2$product_category_2== 1), ]
trainprod22= trainprod2[which(trainprod2$product_category_2== 2), ]
trainprod23= trainprod2[which(trainprod2$product_category_2== 3), ]
trainprod24= trainprod2[which(trainprod2$product_category_2== 4), ]
trainprod25= trainprod2[which(trainprod2$product_category_2== 5), ]
trainprod26= trainprod2[which(trainprod2$product_category_2== 6), ]
trainprod27= trainprod2[which(trainprod2$product_category_2== 7), ]
trainprod28= trainprod2[which(trainprod2$product_category_2== 8), ]
trainprod29= trainprod2[which(trainprod2$product_category_2== 9), ]
trainprod210= trainprod2[which(trainprod2$product_category_2== 10), ]
trainprod211= trainprod2[which(trainprod2$product_category_2== 11), ]
trainprod212= trainprod2[which(trainprod2$product_category_2== 12), ]
trainprod213= trainprod2[which(trainprod2$product_category_2== 13), ]
trainprod214= trainprod2[which(trainprod2$product_category_2== 14), ]
trainprod215= trainprod2[which(trainprod2$product_category_2== 15), ]
trainprod216= trainprod2[which(trainprod2$product_category_2== 16), ]
trainprod217= trainprod2[which(trainprod2$product_category_2== 17), ]
trainprod218= trainprod2[which(trainprod2$product_category_2== 18), ]
trainprod219= trainprod2[which(trainprod2$product_category_2== 19), ]
trainprod220= trainprod2[which(trainprod2$product_category_2== 20), ]
trainprod221= trainprod2[which(trainprod2$product_category_2== 21), ]
trainprod222= trainprod2[which(trainprod2$product_category_2== 22), ]
trainprod223= trainprod2[which(trainprod2$product_category_2== 23), ]
trainprod224= trainprod2[which(trainprod2$product_category_2== 24), ]
trainprod225= trainprod2[which(trainprod2$product_category_2== 25), ]
trainprod226= trainprod2[which(trainprod2$product_category_2== 26), ]
trainprod227= trainprod2[which(trainprod2$product_category_2== 27), ]
trainprod228= trainprod2[which(trainprod2$product_category_2== 28), ]
trainprod229= trainprod2[which(trainprod2$product_category_2== 29), ]
trainprod230= trainprod2[which(trainprod2$product_category_2== 30), ]

trainprod2balance= rbind(trainprod20[1:41,], trainprod21[1:41,], trainprod22[1:41,], trainprod23[1:41,], 
                         trainprod24, trainprod24, trainprod24[1:11,], trainprod25[1:41,], 
                         trainprod26[1:41,], trainprod27[1:41,], 
                         trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, 
                         trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, 
                         trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, 
                         trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, trainprod28, 
                         trainprod28, trainprod29, trainprod29, trainprod29, trainprod29[1:5,], trainprod210[1:41,],
                         trainprod211, trainprod211[1:18,], trainprod212[1:41,], trainprod213, trainprod213[1:13,], 
                         trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, 
                         trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, 
                         trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, 
                         trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, trainprod214, 
                         trainprod214, trainprod215[1,],
                         trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, 
                         trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, trainprod215, 
                         trainprod216[1:41,], trainprod217[1:41,], 
                         trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, 
                         trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, 
                         trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, 
                         trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, trainprod218, 
                         trainprod218, trainprod219, 
                         trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, 
                         trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, 
                         trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, 
                         trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, trainprod219, 
                         trainprod220, trainprod220[1:7,], 
                         trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, 
                         trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, 
                         trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, 
                         trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, trainprod221, 
                         trainprod221, 
                         trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, 
                         trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, 
                         trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, 
                         trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, trainprod226, 
                         trainprod226, trainprod228, 
                         trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, 
                         trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, 
                         trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, 
                         trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, trainprod228, 
                         trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, 
                         trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, 
                         trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, 
                         trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, trainprod230, 
                         trainprod230, trainprod222[1,],  
                         trainprod222, trainprod222, trainprod222, trainprod222, trainprod222, trainprod222, trainprod222, 
                         trainprod222, trainprod222, trainprod222, 
                         trainprod223[1:41,], trainprod224[1:41,], 
                         trainprod225, trainprod225, trainprod225, trainprod225, trainprod225[1,], 
                         trainprod227, trainprod227, trainprod227[1:3,], trainprod229[1:41,])


trainprod2balance= trainprod2balance[sample(nrow(trainprod2balance)), ];    trainprod2balance= trainprod2balance[sample(nrow(trainprod2balance)), ];    trainprod2balance= trainprod2balance[sample(nrow(trainprod2balance)), ]
rownames(trainprod2balance)= c(1:nrow(trainprod2balance))

#write.csv(trainprod2balance, file="D:/American16NovHackathon/trainprod2balance.csv", row.names= FALSE)
#write.csv(testprod2, file="D:/American16NovHackathon/testprod2.csv", row.names= FALSE)








#############################################################################
prod2pred= read.csv("D:/American16NovHackathon/3Layer4LBat128Adadel_Prod2OVERUNDERBesttrainloss.csv")
testprod2$product_category_2= prod2pred$product_category_2

traintestprod2pred= traintestprod2
a= which(is.na(traintestprod2$product_category_2))
traintestprod2pred[a, "product_category_2"]= testprod2$product_category_2

traintestgender= traintestprod2pred
traintestgender$gender= traintest6$gender
traintestgender$product_category_2 = as.factor(as.character(traintestgender$product_category_2))

traintestgender$gender= as.character(traintestgender$gender)
traintestgender$gender= replace(traintestgender$gender, which(traintestgender$gender=="Female"), "0")
traintestgender$gender= replace(traintestgender$gender, which(traintestgender$gender=="Male"), "1")
traintestgender$gender= as.numeric(as.character(traintestgender$gender))
traintestgender= dummy.data.frame(traintestgender, sep="_")

traingender= na.omit(traintestgender)    #568222
testgender= traintestgender[which(is.na(traintestgender$gender)), ]    #23927
testgender$gender= NULL
geomeangender= exp(mean(log(table(traingender$gender))))    #182352.9405
traingender= traingender[sample(nrow(traingender)), ];    traingender= traingender[sample(nrow(traingender)), ];    traingender= traingender[sample(nrow(traingender)), ]
rownames(traingender)= c(1:nrow(traingender))

traingender0= traingender[which(traingender$gender== 0), ]
traingender1= traingender[which(traingender$gender== 1), ]
traingenderbalance= rbind(traingender0, traingender0, traingender0[1:49867,], traingender1[1:182353,])



traingenderbalance= traingenderbalance[sample(nrow(traingenderbalance)), ];    traingenderbalance= traingenderbalance[sample(nrow(traingenderbalance)), ];    traingenderbalance= traingenderbalance[sample(nrow(traingenderbalance)), ]
rownames(traingenderbalance)= c(1:nrow(traingenderbalance))

#write.csv(traingenderbalance, file="D:/American16NovHackathon/traingenderbalance.csv", row.names= FALSE)
#write.csv(testgender, file="D:/American16NovHackathon/testgender.csv", row.names= FALSE)








#############################################################################
genderpred= read.csv("D:/American16NovHackathon/3Layer4LBat128Adadel_GenderOVERUNDERBesttrainloss.csv")
testgender$gender= genderpred$gender

traintestgenderpred= traintestgender
a= which(is.na(traintestgender$gender))
traintestgenderpred[a, "gender"]= testgender$gender

traintestclick= traintestgenderpred
traintestclick$is_click= traintest6$is_click
traintestclick$gender = as.numeric(as.character(traintestclick$gender))

traintestclick$is_click= as.character(traintestclick$is_click)
traintestclick$is_click= as.numeric(as.character(traintestclick$is_click))

trainclick= na.omit(traintestclick)    #463291
testclick= traintestclick[which(is.na(traintestclick$is_click)), ]    #128858
testclick$is_click= NULL
geomeanclick= exp(mean(log(table(trainclick$is_click))))    #116334.59829
trainclick= trainclick[sample(nrow(trainclick)), ];    trainclick= trainclick[sample(nrow(trainclick)), ];    trainclick= trainclick[sample(nrow(trainclick)), ]
rownames(trainclick)= c(1:nrow(trainclick))

trainclick0= trainclick[which(trainclick$is_click== 0), ]
trainclick1= trainclick[which(trainclick$is_click== 1), ]

trainclickbalance= rbind(trainclick0[1:116335,], trainclick1, trainclick1, trainclick1, trainclick1[1:22341,])


trainclickbalance= trainclickbalance[sample(nrow(trainclickbalance)), ];    trainclickbalance= trainclickbalance[sample(nrow(trainclickbalance)), ];    trainclickbalance= trainclickbalance[sample(nrow(trainclickbalance)), ]
rownames(trainclickbalance)= c(1:nrow(trainclickbalance))

#write.csv(trainclickbalance, file="D:/American16NovHackathon/trainclickbalance.csv", row.names= FALSE)
#write.csv(testclick, file="D:/American16NovHackathon/testclick.csv", row.names= FALSE)





trainclickbalanceNOVAR= trainclickbalance
trainclickbalanceNOVAR$var_1= NULL
testclickNOVAR= testclick
testclickNOVAR$var_1= NULL
#write.csv(trainclickbalanceNOVAR, file="D:/American16NovHackathon/trainclickbalanceNOVAR.csv", row.names= FALSE)
#write.csv(testclickNOVAR, file="D:/American16NovHackathon/testclickNOVAR.csv", row.names= FALSE)




















testrawwithvaraction= testrawdummy
a= order(match(traintest6WithVar$session_id, testrawdummy$session_id))
testrawwithvaraction$action= traintest6WithVar[a[1:128858], "action"]
testrawwithvaraction$var_1= traintest6WithVar[a[1:128858], "var_1"]
testrawwithvaraction= dummy.data.frame(testrawwithvaraction, sep="_")
#write.csv(testrawwithvaraction, file="D:/American16NovHackathon/testrawwithvaraction.csv", row.names= FALSE)


trainrawwithvaraction= trainrawdummy
a= order(match(traintest6WithVar$session_id, trainrawdummy$session_id))
trainrawwithvaraction$action= traintest6WithVar[a[1:463291], "action"]
trainrawwithvaraction$var_1= traintest6WithVar[a[1:463291], "var_1"]
trainrawwithvaraction= trainrawwithvaraction[, colnames(trainrawwithvaraction)[c(1:46,48,49,47)]]
trainrawwithvaraction= dummy.data.frame(trainrawwithvaraction, sep="_")

#BALANCE THE DATA
trainrawwithvaraction0= trainrawwithvaraction[which(trainrawwithvaraction$is_click== 0), ]
trainrawwithvaraction1= trainrawwithvaraction[which(trainrawwithvaraction$is_click== 1), ]
trainrawwithvaractionbal= rbind(trainrawwithvaraction1, trainrawwithvaraction1, trainrawwithvaraction1, trainrawwithvaraction1[1:22342,], trainrawwithvaraction0[1:116335,])
trainrawwithvaractionbal= trainrawwithvaractionbal[sample(nrow(trainrawwithvaractionbal)), ];    trainrawwithvaractionbal= trainrawwithvaractionbal[sample(nrow(trainrawwithvaractionbal)), ];    trainrawwithvaractionbal= trainrawwithvaractionbal[sample(nrow(trainrawwithvaractionbal)), ]
rownames(trainrawwithvaractionbal)= 1:nrow(trainrawwithvaractionbal)
#write.csv(trainrawwithvaractionbal, file="D:/American16NovHackathon/trainrawwithvaractionbal.csv", row.names= FALSE)







b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.05= b;     bm0.05$is_click= bm0.05$is_click-0.05
bm0.05$is_click= replace(bm0.05$is_click, which(bm0.05$is_click<0), 0)
write.csv(bm0.05, file="D:/American16NovHackathon/bm0_05.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.1= b;     bm0.1$is_click= bm0.1$is_click-0.1
bm0.1$is_click= replace(bm0.1$is_click, which(bm0.1$is_click<0), 0)
write.csv(bm0.1, file="D:/American16NovHackathon/bm0_1.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.15= b;     bm0.15$is_click= bm0.15$is_click-0.15
bm0.15$is_click= replace(bm0.15$is_click, which(bm0.15$is_click<0), 0)
write.csv(bm0.15, file="D:/American16NovHackathon/bm0_15.csv", row.names= FALSE)




b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.2= b;     bm0.2$is_click= bm0.2$is_click-0.2
bm0.2$is_click= replace(bm0.2$is_click, which(bm0.2$is_click<0), 0)
write.csv(bm0.2, file="D:/American16NovHackathon/bm0_2.csv", row.names= FALSE)




b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.25= b;     bm0.25$is_click= bm0.25$is_click-0.25
bm0.25$is_click= replace(bm0.25$is_click, which(bm0.25$is_click<0), 0)
write.csv(bm0.25, file="D:/American16NovHackathon/bm0_25.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.3= b;     bm0.3$is_click= bm0.3$is_click-0.3
bm0.3$is_click= replace(bm0.3$is_click, which(bm0.3$is_click<0), 0)
write.csv(bm0.3, file="D:/American16NovHackathon/bm0_3.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.35= b;     bm0.35$is_click= bm0.35$is_click-0.35
bm0.35$is_click= replace(bm0.35$is_click, which(bm0.35$is_click<0), 0)
write.csv(bm0.35, file="D:/American16NovHackathon/bm0_35.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.4= b;     bm0.4$is_click= bm0.4$is_click-0.4
bm0.4$is_click= replace(bm0.4$is_click, which(bm0.4$is_click<0), 0)
write.csv(bm0.4, file="D:/American16NovHackathon/bm0_4.csv", row.names= FALSE)




b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.45= b;     bm0.45$is_click= bm0.45$is_click-0.45
bm0.45$is_click= replace(bm0.45$is_click, which(bm0.45$is_click<0), 0)
write.csv(bm0.45, file="D:/American16NovHackathon/bm0_45.csv", row.names= FALSE)




b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.43238= b;     bm0.43238$is_click= bm0.43238$is_click-43238
bm0.43238$is_click= replace(bm0.43238$is_click, which(bm0.43238$is_click<0), 0)
write.csv(bm0.43238, file="D:/American16NovHackathon/bm0_43238.csv", row.names= FALSE)



b= read.csv("D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.csv")
bm0.43= b;     bm0.43$is_click= bm0.43$is_click-43
bm0.43$is_click= replace(bm0.43$is_click, which(bm0.43$is_click<0), 0)
write.csv(bm0.43, file="D:/American16NovHackathon/bm0_43.csv", row.names= FALSE)
