
try:
    from IPython import get_ipython
    get_ipython().magic('reset -sf');    get_ipython().magic('reset -f')
except:
    pass

import numpy as np
import pandas, cv2, tensorflow, os, copy, glob, random, sys, math
from six.moves import xrange
from copy import deepcopy
#from sklearn.model_selection import train_test_split, cross_val_score, KFold
from keras.layers.convolutional import Conv2D, MaxPooling2D, UpSampling2D, ZeroPadding2D
from keras.layers import Input, Conv2DTranspose, Reshape, Dense, Dropout, Flatten, BatchNormalization, Dropout, Activation
from keras.models import Sequential, Model, load_model
from keras.callbacks import TensorBoard, ModelCheckpoint
#from keras.datasets import mnist
from keras.optimizers import Adam, Adadelta, Nadam
from keras.layers.core import Activation, Flatten, Dense
from keras.preprocessing.image import ImageDataGenerator
#from pylab import *
#from skimage import color, io
#from matplotlib import pyplot
from PIL import Image, ImageChops #, ImageTk
from keras import backend as K
from keras.utils import np_utils
np.random.seed(9)
import random
#from IPython import get_ipython
split= 0.10
irsModelPath = 'D:/American16NovHackathon/3Layer4LBat32Adadel_RAWDATAOVERUNDERBesttrainloss.h5'


# In[ ]:



if 1:
    try:
        os.environ["CUDA_VISIBLE_DEVICES"]= '0'
        num_cores= 4;    num_CPU= 3    #Set the number of CPUs and cores to be used
        #Utilise the GPU
        config= tensorflow.ConfigProto(intra_op_parallelism_threads=num_cores,            inter_op_parallelism_threads=num_cores, allow_soft_placement=True,            device_count = {'CPU' : num_CPU, 'GPU' : 1})
        session= tensorflow.Session(config= config);    print(config)
        K.set_session(session)
    except:
        pass





import csv
train= pandas.read_csv('D:/American16NovHackathon/trainrawdummyoverunder.csv')
test= pandas.read_csv('D:/American16NovHackathon/testrawdummy.csv')

X_train= np.array(train);    y_train=X_train[:,46];     X_train= np.array(X_train[:,1:46])
X_test= np.array(test);    X_test= np.array(X_test[:,1:46])

y_train = np_utils.to_categorical(y_train)
shptrain= np.shape(X_train);     shptest= np.shape(X_test)




from keras.models import Sequential
from keras.layers import Dense
from keras.wrappers.scikit_learn import KerasClassifier
from keras.utils import np_utils
#from sklearn.model_selection import cross_val_score
#from sklearn.model_selection import KFold
#from sklearn.preprocessing import LabelEncoder
#from sklearn.pipeline import Pipeline



############################################
mymodel = Sequential()
mymodel.add(Dense(192, input_dim=shptrain[1], use_bias=False))
mymodel.add(Dense(48, activation='relu', use_bias=True))
mymodel.add(Dense(2, activation='softmax'))
######################################################



print(irsModelPath)
print(mymodel.summary())




print(irsModelPath)
mymodel.compile(optimizer='adadelta', loss='categorical_crossentropy', metrics=['accuracy'])

callbacks= [ ModelCheckpoint(irsModelPath, monitor='val_acc', save_best_only=True, verbose=1, mode='auto', period=1),
    TensorBoard(log_dir='/tmp/tb', histogram_freq=0, write_graph=False) ]

mymodel.fit(X_train, y_train,
                    epochs= 400000, batch_size= 32,
                    shuffle= True, validation_data= (X_train, y_train),
                    callbacks= callbacks)    


bestmodel= load_model(irsModelPath)
y_test= bestmodel.predict(X_test)














####################################################################

import numpy as np
import pandas, cv2, tensorflow, os, copy, glob, random, sys, math
from six.moves import xrange
from copy import deepcopy
#from sklearn.model_selection import train_test_split, cross_val_score, KFold
from keras.layers.convolutional import Conv2D, MaxPooling2D, UpSampling2D, ZeroPadding2D
from keras.layers import Input, Conv2DTranspose, Reshape, Dense, Dropout, Flatten, BatchNormalization, Dropout, Activation
from keras.models import Sequential, Model, load_model
from keras.callbacks import TensorBoard, ModelCheckpoint, ReduceLROnPlateau
#from keras.datasets import mnist
from keras.optimizers import Adam, Adadelta, Nadam
from keras.layers.core import Activation, Flatten, Dense
from keras.preprocessing.image import ImageDataGenerator
#from pylab import *
#from skimage import color, io
#from matplotlib import pyplot
from PIL import Image, ImageChops #, ImageTk
from keras import backend as K
from keras.utils import np_utils
np.random.seed(9)
import random
#from IPython import get_ipython
split= 0.10

import csv


from keras.models import Sequential
from keras.layers import Dense
from keras.wrappers.scikit_learn import KerasClassifier
from keras.utils import np_utils

filename= "3Layer4LBat32Adadel_ClickOVERUNDERBesttrainloss"    #################
irsModelPath = 'D:/American16NovHackathon/'+ filename+ ".h5"
print(irsModelPath)
bestmodel= load_model(irsModelPath)

test= pandas.read_csv('D:/American16NovHackathon/testclick.csv')    #################
X_test= np.array(test);    print(np.shape(X_test))
X_test= np.array(X_test[:,1:106])    #################
shptest= np.shape(X_test);    print(shptest)

y_test= bestmodel.predict(X_test)

print(np.shape(y_test))
y_test

#df= pandas.DataFrame(np.array(test)[:,0], y_test[:,1])#, columns= ("session_id", "is_click"))
df= pandas.concat([pandas.DataFrame(np.array(test)[:,0], columns= {"session_id"}), pandas.DataFrame(y_test[:,1], columns= {"is_click"})], axis=1)
df.to_csv('D:/American16NovHackathon/'+ filename+ ".csv", index=False)    #################
df